import * as React from 'react'
import {cva, type VariantProps} from 'class-variance-authority'

import {merge} from '@/lib/utils'

const alertVariants = cva(
  'relative w-full rounded-lg px-4 py-3 text-sm grid has-[>svg]:grid-cols-[calc(var(--spacing)*4)_1fr] grid-cols-[0_1fr] has-[>svg]:gap-x-3 gap-y-0.5 items-start [&>svg]:size-4 [&>svg]:translate-y-0.5 [&>svg]:text-current',
  {
    variants: {
      variant: {
        default: 'text-primary bg-primary/10 *:data-[slot=alert-description]:text-primary/90',
        done: 'text-done bg-done/10 *:data-[slot=alert-description]:text-done/90',
        warn: 'text-warn bg-warn/10 *:data-[slot=alert-description]:text-warn/90',
        fail: 'text-fail bg-fail/10 *:data-[slot=alert-description]:text-fail/90',
      },
    },
    defaultVariants: {
      variant: 'default',
    },
  },
)

function Alert({
  className,
  variant,
  ...props
}: React.ComponentProps<'div'> & VariantProps<typeof alertVariants>) {
  return (
    <div
      data-slot="alert"
      role="alert"
      className={merge(alertVariants({variant}), className)}
      {...props}
    />
  )
}

function AlertTitle({className, ...props}: React.ComponentProps<'div'>) {
  return (
    <div
      data-slot="alert-title"
      className={merge(
        'col-start-2 line-clamp-1 min-h-4 tracking-tight',
        className,
      )}
      {...props}
    />
  )
}

function AlertDescription({
  className,
  ...props
}: React.ComponentProps<'div'>) {
  return (
    <div
      data-slot="alert-description"
      className={merge(
        'text-muted-foreground col-start-2 grid justify-items-start gap-1 text-sm [&_p]:leading-relaxed',
        className,
      )}
      {...props}
    />
  )
}

export {Alert, AlertTitle, AlertDescription}
